# The pinhole camera model
# lp = K R [I | -c] P
#
# Program to calculate the rotatio matriz R
#
# Fraga
# 13.05.2025
#
# We need the values of
# vc, the camera position
# up, the vector that indicates the up direction for the camera
# vo, a point where the camera in pointing at

import sys
import numpy as np
from numpy.linalg import norm

n = len( sys.argv )
if n != 10 :
	print("Args: cx cy cz  upx upy upz  ox oy oz" )
	sys.exit(1)

vc = np.zeros( (3,1) ) 
vup = np.zeros( (3,1) ) 
vo = np.zeros( (3,1) ) 

vc[0,0] = float( sys.argv[1] )
vc[1,0] = float( sys.argv[2] )
vc[2,0] = float( sys.argv[3] )

vup[0,0] = float( sys.argv[4] )
vup[1,0] = float( sys.argv[5] )
vup[2,0] = float( sys.argv[6] )

vo[0,0] = float( sys.argv[7] )
vo[1,0] = float( sys.argv[8] )
vo[2,0] = float( sys.argv[9] )

va = vc - vo
vz = va/norm( va )

vb = np.cross( vup, vz, axis=0 )
vx = vb/norm(vb)


vy = np.cross( vz, vx, axis=0 )

R = np.vstack( [vx.T, vy.T, vz.T] )
print( R )

np.savetxt( "R.txt", R ) 
np.savetxt( "vc.txt", vc ) 


