# Program to project a 3D model
# according to the pinhole camera model:
#
# lp = K R [I | -c] P
#
import numpy as np
import model2D

R = np.loadtxt( "R.txt" )
vc = np.loadtxt( "vc.txt" )
vc = vc.reshape( -1,1 )
# print( vc.shape )

# The K matrix
f = 1000
K = np.array( [[-f, 0, 300 ],
               [ 0,-f, 200 ],
               [ 0, 0,   1 ] ] ) 

P1 = np.array( [[-5],[ 5],[0]] )
P2 = np.array( [[-5],[-5],[0]] )
P3 = np.array( [[ 5],[-5],[0]] )
P4 = np.array( [[ 5],[ 5],[0]] )

P5 = np.array( [[-5],[ 5],[10]] )
P6 = np.array( [[-5],[-5],[10]] )
P7 = np.array( [[ 5],[-5],[10]] )
P8 = np.array( [[ 5],[ 5],[10]] )

P = np.hstack( (P1,P2,P3,P4,P5,P6,P7,P8) )
# 3x8

n, m = P.shape
# The proyected coordinates of the 3D model
# is a set of m 2D points
p = np.zeros( (2,m) )

# lp = K R [I | -c] P
i = 0
while i < m :
	# P1 = [I | -c] P
	Pa = P[:,i].reshape(-1,1)
	Pp = Pa - vc
	# print( i, Pp.shape )
	# P2 = R P1
	Ppp = R @ Pp
	lp = K @ Ppp
	p[0,i] = lp[0,0]/lp[2,0]
	p[1,i] = lp[1,0]/lp[2,0]

	i += 1

# print( p )

model2D.print2DModel( p )
